// Package api provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package api

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"
	"time"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
	"github.com/oapi-codegen/runtime"
	strictnethttp "github.com/oapi-codegen/runtime/strictmiddleware/nethttp"
	openapi_types "github.com/oapi-codegen/runtime/types"
	externalRef0 "gitlab.com/digilab.overheid.nl/ecosystem/fsc-vwl-api"
)

// Attribute merged value of an attribute, including all observations about it.
type Attribute struct {
	Observations []Observation `json:"observations"`
	Value        interface{}   `json:"value"`
}

// Error The error that occured while processing this request.
type Error struct {
	Message string `json:"message"`
}

// Observation Moment of registration of a specific observation of a vreemdeling.
type Observation struct {
	Attribute string    `json:"attribute"`
	CreatedAt time.Time `json:"createdAt"`

	// Id UUID of observation.
	Id            ObservationId `json:"id"`
	InvalidatedAt *time.Time    `json:"invalidatedAt,omitempty"`
	Source        string        `json:"source"`
	Value         interface{}   `json:"value"`
}

// Proces Proces with its attributes
type Proces struct {
	Attributes    *map[string]Attribute `json:"attributes,omitempty"`
	CreatedAt     time.Time             `json:"createdAt"`
	DeletedAt     *time.Time            `json:"deletedAt,omitempty"`
	Id            openapi_types.UUID    `json:"id"`
	ProcesId      string                `json:"procesId"`
	Source        string                `json:"source"`
	Status        string                `json:"status"`
	Type          string                `json:"type"`
	VreemdelingId string                `json:"vreemdelingId"`
}

// ProcesResponse Proces response
type ProcesResponse struct {
	// Data Proces with its attributes
	Data Proces `json:"data"`
}

// ProcessenResponse Processen response
type ProcessenResponse struct {
	Data []Proces `json:"data"`
}

// VreemdelingWithObservations A known vreemdeling, with merged attributes and full list of relevant observations.
type VreemdelingWithObservations struct {
	// Id V-number of vreemdeling.
	Id                   VreemdelingId        `json:"id"`
	AdditionalProperties map[string]Attribute `json:"-"`
}

// VreemdelingWithObservationsResponse Vreemdeling with observations response
type VreemdelingWithObservationsResponse struct {
	// Data A known vreemdeling, with merged attributes and full list of relevant observations.
	Data VreemdelingWithObservations `json:"data"`
}

// ObservationId UUID of observation.
type ObservationId = openapi_types.UUID

// ProcesId UUID of proces.
type ProcesId = openapi_types.UUID

// VreemdelingId V-number of vreemdeling.
type VreemdelingId = string

// PathProcesId UUID of proces.
type PathProcesId = ProcesId

// PathVreemdelingId V-number of vreemdeling.
type PathVreemdelingId = VreemdelingId

// QueryAttributes defines model for queryAttributes.
type QueryAttributes = []string

// QueryAttributesOptional defines model for queryAttributesOptional.
type QueryAttributesOptional = []string

// QuerySources defines model for querySources.
type QuerySources = []string

// BadRequestErrorResponse defines model for BadRequestErrorResponse.
type BadRequestErrorResponse struct {
	Errors []Error `json:"errors"`
}

// GoneErrorResponse defines model for GoneErrorResponse.
type GoneErrorResponse struct {
	Errors []Error `json:"errors"`
}

// ReadProcessenParams defines parameters for ReadProcessen.
type ReadProcessenParams struct {
	// Attributes Comma-separated list of attributes to show.
	Attributes *QueryAttributesOptional `form:"attributes,omitempty" json:"attributes,omitempty"`

	// Sources Comma-separated list of SIGMA sources to query. Query all sources if not specified.
	Sources *QuerySources `form:"sources,omitempty" json:"sources,omitempty"`

	// FSCVWLVerwerkingsActiviteit id of the verwerking type
	FSCVWLVerwerkingsActiviteit *externalRef0.FSCVWLVerwerkingsActiviteit `json:"FSC-VWL-Verwerkings-Activiteit,omitempty"`

	// FSCVWLVerwerkingsSpan transaction uuid of the incoming request
	FSCVWLVerwerkingsSpan *externalRef0.FSCVWLVerwerkingsSpan `json:"FSC-VWL-Verwerkings-Span,omitempty"`

	// FSCVWLSysteem identifier for the system processing the verwerking
	FSCVWLSysteem *externalRef0.FSCVWLSysteem `json:"FSC-VWL-Systeem,omitempty"`

	// FSCVWLVerwerker the party doing the verwerking, this does not have to be the party responsible for the verwerking
	FSCVWLVerwerker *externalRef0.FSCVWLVerwerker `json:"FSC-VWL-Verwerker,omitempty"`

	// FSCVWLVerantwoordelijke the party responsible for the verwerking, this does not have to be the party doing the verwerking itself
	FSCVWLVerantwoordelijke *externalRef0.FSCVWLVerantwoordelijke `json:"FSC-VWL-Verantwoordelijke,omitempty"`
}

// ReadProcesByIdParams defines parameters for ReadProcesById.
type ReadProcesByIdParams struct {
	// Attributes Comma-separated list of attributes to show.
	Attributes *QueryAttributesOptional `form:"attributes,omitempty" json:"attributes,omitempty"`

	// Sources Comma-separated list of SIGMA sources to query. Query all sources if not specified.
	Sources *QuerySources `form:"sources,omitempty" json:"sources,omitempty"`

	// FSCVWLVerwerkingsActiviteit id of the verwerking type
	FSCVWLVerwerkingsActiviteit *externalRef0.FSCVWLVerwerkingsActiviteit `json:"FSC-VWL-Verwerkings-Activiteit,omitempty"`

	// FSCVWLVerwerkingsSpan transaction uuid of the incoming request
	FSCVWLVerwerkingsSpan *externalRef0.FSCVWLVerwerkingsSpan `json:"FSC-VWL-Verwerkings-Span,omitempty"`

	// FSCVWLSysteem identifier for the system processing the verwerking
	FSCVWLSysteem *externalRef0.FSCVWLSysteem `json:"FSC-VWL-Systeem,omitempty"`

	// FSCVWLVerwerker the party doing the verwerking, this does not have to be the party responsible for the verwerking
	FSCVWLVerwerker *externalRef0.FSCVWLVerwerker `json:"FSC-VWL-Verwerker,omitempty"`

	// FSCVWLVerantwoordelijke the party responsible for the verwerking, this does not have to be the party doing the verwerking itself
	FSCVWLVerantwoordelijke *externalRef0.FSCVWLVerantwoordelijke `json:"FSC-VWL-Verantwoordelijke,omitempty"`
}

// ReadVreemdelingByIdParams defines parameters for ReadVreemdelingById.
type ReadVreemdelingByIdParams struct {
	// Attributes Comma-separated list of required attributes to show.
	Attributes QueryAttributes `form:"attributes" json:"attributes"`

	// Sources Comma-separated list of SIGMA sources to query. Query all sources if not specified.
	Sources *QuerySources `form:"sources,omitempty" json:"sources,omitempty"`

	// FSCVWLVerwerkingsActiviteit id of the verwerking type
	FSCVWLVerwerkingsActiviteit *externalRef0.FSCVWLVerwerkingsActiviteit `json:"FSC-VWL-Verwerkings-Activiteit,omitempty"`

	// FSCVWLVerwerkingsSpan transaction uuid of the incoming request
	FSCVWLVerwerkingsSpan *externalRef0.FSCVWLVerwerkingsSpan `json:"FSC-VWL-Verwerkings-Span,omitempty"`

	// FSCVWLSysteem identifier for the system processing the verwerking
	FSCVWLSysteem *externalRef0.FSCVWLSysteem `json:"FSC-VWL-Systeem,omitempty"`

	// FSCVWLVerwerker the party doing the verwerking, this does not have to be the party responsible for the verwerking
	FSCVWLVerwerker *externalRef0.FSCVWLVerwerker `json:"FSC-VWL-Verwerker,omitempty"`

	// FSCVWLVerantwoordelijke the party responsible for the verwerking, this does not have to be the party doing the verwerking itself
	FSCVWLVerantwoordelijke *externalRef0.FSCVWLVerantwoordelijke `json:"FSC-VWL-Verantwoordelijke,omitempty"`
}

// ReadProcessenByVreemdelingIdParams defines parameters for ReadProcessenByVreemdelingId.
type ReadProcessenByVreemdelingIdParams struct {
	// Attributes Comma-separated list of attributes to show.
	Attributes *QueryAttributesOptional `form:"attributes,omitempty" json:"attributes,omitempty"`

	// Sources Comma-separated list of SIGMA sources to query. Query all sources if not specified.
	Sources *QuerySources `form:"sources,omitempty" json:"sources,omitempty"`

	// FSCVWLVerwerkingsActiviteit id of the verwerking type
	FSCVWLVerwerkingsActiviteit *externalRef0.FSCVWLVerwerkingsActiviteit `json:"FSC-VWL-Verwerkings-Activiteit,omitempty"`

	// FSCVWLVerwerkingsSpan transaction uuid of the incoming request
	FSCVWLVerwerkingsSpan *externalRef0.FSCVWLVerwerkingsSpan `json:"FSC-VWL-Verwerkings-Span,omitempty"`

	// FSCVWLSysteem identifier for the system processing the verwerking
	FSCVWLSysteem *externalRef0.FSCVWLSysteem `json:"FSC-VWL-Systeem,omitempty"`

	// FSCVWLVerwerker the party doing the verwerking, this does not have to be the party responsible for the verwerking
	FSCVWLVerwerker *externalRef0.FSCVWLVerwerker `json:"FSC-VWL-Verwerker,omitempty"`

	// FSCVWLVerantwoordelijke the party responsible for the verwerking, this does not have to be the party doing the verwerking itself
	FSCVWLVerantwoordelijke *externalRef0.FSCVWLVerantwoordelijke `json:"FSC-VWL-Verantwoordelijke,omitempty"`
}

// Getter for additional properties for VreemdelingWithObservations. Returns the specified
// element and whether it was found
func (a VreemdelingWithObservations) Get(fieldName string) (value Attribute, found bool) {
	if a.AdditionalProperties != nil {
		value, found = a.AdditionalProperties[fieldName]
	}
	return
}

// Setter for additional properties for VreemdelingWithObservations
func (a *VreemdelingWithObservations) Set(fieldName string, value Attribute) {
	if a.AdditionalProperties == nil {
		a.AdditionalProperties = make(map[string]Attribute)
	}
	a.AdditionalProperties[fieldName] = value
}

// Override default JSON handling for VreemdelingWithObservations to handle AdditionalProperties
func (a *VreemdelingWithObservations) UnmarshalJSON(b []byte) error {
	object := make(map[string]json.RawMessage)
	err := json.Unmarshal(b, &object)
	if err != nil {
		return err
	}

	if raw, found := object["id"]; found {
		err = json.Unmarshal(raw, &a.Id)
		if err != nil {
			return fmt.Errorf("error reading 'id': %w", err)
		}
		delete(object, "id")
	}

	if len(object) != 0 {
		a.AdditionalProperties = make(map[string]Attribute)
		for fieldName, fieldBuf := range object {
			var fieldVal Attribute
			err := json.Unmarshal(fieldBuf, &fieldVal)
			if err != nil {
				return fmt.Errorf("error unmarshaling field %s: %w", fieldName, err)
			}
			a.AdditionalProperties[fieldName] = fieldVal
		}
	}
	return nil
}

// Override default JSON handling for VreemdelingWithObservations to handle AdditionalProperties
func (a VreemdelingWithObservations) MarshalJSON() ([]byte, error) {
	var err error
	object := make(map[string]json.RawMessage)

	object["id"], err = json.Marshal(a.Id)
	if err != nil {
		return nil, fmt.Errorf("error marshaling 'id': %w", err)
	}

	for fieldName, field := range a.AdditionalProperties {
		object[fieldName], err = json.Marshal(field)
		if err != nil {
			return nil, fmt.Errorf("error marshaling '%s': %w", fieldName, err)
		}
	}
	return json.Marshal(object)
}

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// ReadProcessen request
	ReadProcessen(ctx context.Context, params *ReadProcessenParams, reqEditors ...RequestEditorFn) (*http.Response, error)

	// ReadProcesById request
	ReadProcesById(ctx context.Context, procesId PathProcesId, params *ReadProcesByIdParams, reqEditors ...RequestEditorFn) (*http.Response, error)

	// ReadVreemdelingById request
	ReadVreemdelingById(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams, reqEditors ...RequestEditorFn) (*http.Response, error)

	// ReadProcessenByVreemdelingId request
	ReadProcessenByVreemdelingId(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) ReadProcessen(ctx context.Context, params *ReadProcessenParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewReadProcessenRequest(c.Server, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) ReadProcesById(ctx context.Context, procesId PathProcesId, params *ReadProcesByIdParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewReadProcesByIdRequest(c.Server, procesId, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) ReadVreemdelingById(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewReadVreemdelingByIdRequest(c.Server, vreemdelingId, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) ReadProcessenByVreemdelingId(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewReadProcessenByVreemdelingIdRequest(c.Server, vreemdelingId, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewReadProcessenRequest generates requests for ReadProcessen
func NewReadProcessenRequest(server string, params *ReadProcessenParams) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/processen")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if params.Attributes != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "attributes", runtime.ParamLocationQuery, *params.Attributes); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.Sources != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "sources", runtime.ParamLocationQuery, *params.Sources); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	if params != nil {

		if params.FSCVWLVerwerkingsActiviteit != nil {
			var headerParam0 string

			headerParam0, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerkings-Activiteit", runtime.ParamLocationHeader, *params.FSCVWLVerwerkingsActiviteit)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerkings-Activiteit", headerParam0)
		}

		if params.FSCVWLVerwerkingsSpan != nil {
			var headerParam1 string

			headerParam1, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerkings-Span", runtime.ParamLocationHeader, *params.FSCVWLVerwerkingsSpan)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerkings-Span", headerParam1)
		}

		if params.FSCVWLSysteem != nil {
			var headerParam2 string

			headerParam2, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Systeem", runtime.ParamLocationHeader, *params.FSCVWLSysteem)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Systeem", headerParam2)
		}

		if params.FSCVWLVerwerker != nil {
			var headerParam3 string

			headerParam3, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerker", runtime.ParamLocationHeader, *params.FSCVWLVerwerker)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerker", headerParam3)
		}

		if params.FSCVWLVerantwoordelijke != nil {
			var headerParam4 string

			headerParam4, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verantwoordelijke", runtime.ParamLocationHeader, *params.FSCVWLVerantwoordelijke)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verantwoordelijke", headerParam4)
		}

	}

	return req, nil
}

// NewReadProcesByIdRequest generates requests for ReadProcesById
func NewReadProcesByIdRequest(server string, procesId PathProcesId, params *ReadProcesByIdParams) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "procesId", runtime.ParamLocationPath, procesId)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/processen/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if params.Attributes != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "attributes", runtime.ParamLocationQuery, *params.Attributes); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.Sources != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "sources", runtime.ParamLocationQuery, *params.Sources); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	if params != nil {

		if params.FSCVWLVerwerkingsActiviteit != nil {
			var headerParam0 string

			headerParam0, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerkings-Activiteit", runtime.ParamLocationHeader, *params.FSCVWLVerwerkingsActiviteit)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerkings-Activiteit", headerParam0)
		}

		if params.FSCVWLVerwerkingsSpan != nil {
			var headerParam1 string

			headerParam1, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerkings-Span", runtime.ParamLocationHeader, *params.FSCVWLVerwerkingsSpan)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerkings-Span", headerParam1)
		}

		if params.FSCVWLSysteem != nil {
			var headerParam2 string

			headerParam2, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Systeem", runtime.ParamLocationHeader, *params.FSCVWLSysteem)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Systeem", headerParam2)
		}

		if params.FSCVWLVerwerker != nil {
			var headerParam3 string

			headerParam3, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerker", runtime.ParamLocationHeader, *params.FSCVWLVerwerker)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerker", headerParam3)
		}

		if params.FSCVWLVerantwoordelijke != nil {
			var headerParam4 string

			headerParam4, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verantwoordelijke", runtime.ParamLocationHeader, *params.FSCVWLVerantwoordelijke)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verantwoordelijke", headerParam4)
		}

	}

	return req, nil
}

// NewReadVreemdelingByIdRequest generates requests for ReadVreemdelingById
func NewReadVreemdelingByIdRequest(server string, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "vreemdelingId", runtime.ParamLocationPath, vreemdelingId)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/vreemdelingen/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if queryFrag, err := runtime.StyleParamWithLocation("form", false, "attributes", runtime.ParamLocationQuery, params.Attributes); err != nil {
			return nil, err
		} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
			return nil, err
		} else {
			for k, v := range parsed {
				for _, v2 := range v {
					queryValues.Add(k, v2)
				}
			}
		}

		if params.Sources != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "sources", runtime.ParamLocationQuery, *params.Sources); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	if params != nil {

		if params.FSCVWLVerwerkingsActiviteit != nil {
			var headerParam0 string

			headerParam0, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerkings-Activiteit", runtime.ParamLocationHeader, *params.FSCVWLVerwerkingsActiviteit)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerkings-Activiteit", headerParam0)
		}

		if params.FSCVWLVerwerkingsSpan != nil {
			var headerParam1 string

			headerParam1, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerkings-Span", runtime.ParamLocationHeader, *params.FSCVWLVerwerkingsSpan)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerkings-Span", headerParam1)
		}

		if params.FSCVWLSysteem != nil {
			var headerParam2 string

			headerParam2, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Systeem", runtime.ParamLocationHeader, *params.FSCVWLSysteem)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Systeem", headerParam2)
		}

		if params.FSCVWLVerwerker != nil {
			var headerParam3 string

			headerParam3, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerker", runtime.ParamLocationHeader, *params.FSCVWLVerwerker)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerker", headerParam3)
		}

		if params.FSCVWLVerantwoordelijke != nil {
			var headerParam4 string

			headerParam4, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verantwoordelijke", runtime.ParamLocationHeader, *params.FSCVWLVerantwoordelijke)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verantwoordelijke", headerParam4)
		}

	}

	return req, nil
}

// NewReadProcessenByVreemdelingIdRequest generates requests for ReadProcessenByVreemdelingId
func NewReadProcessenByVreemdelingIdRequest(server string, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "vreemdelingId", runtime.ParamLocationPath, vreemdelingId)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/vreemdelingen/%s/processen", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if params.Attributes != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "attributes", runtime.ParamLocationQuery, *params.Attributes); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.Sources != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "sources", runtime.ParamLocationQuery, *params.Sources); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	if params != nil {

		if params.FSCVWLVerwerkingsActiviteit != nil {
			var headerParam0 string

			headerParam0, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerkings-Activiteit", runtime.ParamLocationHeader, *params.FSCVWLVerwerkingsActiviteit)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerkings-Activiteit", headerParam0)
		}

		if params.FSCVWLVerwerkingsSpan != nil {
			var headerParam1 string

			headerParam1, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerkings-Span", runtime.ParamLocationHeader, *params.FSCVWLVerwerkingsSpan)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerkings-Span", headerParam1)
		}

		if params.FSCVWLSysteem != nil {
			var headerParam2 string

			headerParam2, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Systeem", runtime.ParamLocationHeader, *params.FSCVWLSysteem)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Systeem", headerParam2)
		}

		if params.FSCVWLVerwerker != nil {
			var headerParam3 string

			headerParam3, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerker", runtime.ParamLocationHeader, *params.FSCVWLVerwerker)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerker", headerParam3)
		}

		if params.FSCVWLVerantwoordelijke != nil {
			var headerParam4 string

			headerParam4, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verantwoordelijke", runtime.ParamLocationHeader, *params.FSCVWLVerantwoordelijke)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verantwoordelijke", headerParam4)
		}

	}

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// ReadProcessenWithResponse request
	ReadProcessenWithResponse(ctx context.Context, params *ReadProcessenParams, reqEditors ...RequestEditorFn) (*ReadProcessenResponse, error)

	// ReadProcesByIdWithResponse request
	ReadProcesByIdWithResponse(ctx context.Context, procesId PathProcesId, params *ReadProcesByIdParams, reqEditors ...RequestEditorFn) (*ReadProcesByIdResponse, error)

	// ReadVreemdelingByIdWithResponse request
	ReadVreemdelingByIdWithResponse(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams, reqEditors ...RequestEditorFn) (*ReadVreemdelingByIdResponse, error)

	// ReadProcessenByVreemdelingIdWithResponse request
	ReadProcessenByVreemdelingIdWithResponse(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams, reqEditors ...RequestEditorFn) (*ReadProcessenByVreemdelingIdResponse, error)
}

type ReadProcessenResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *ProcessenResponse
	JSON400      *BadRequestErrorResponse
}

// Status returns HTTPResponse.Status
func (r ReadProcessenResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ReadProcessenResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type ReadProcesByIdResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *ProcesResponse
	JSON400      *BadRequestErrorResponse
}

// Status returns HTTPResponse.Status
func (r ReadProcesByIdResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ReadProcesByIdResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type ReadVreemdelingByIdResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *VreemdelingWithObservationsResponse
	JSON400      *BadRequestErrorResponse
	JSON410      *GoneErrorResponse
}

// Status returns HTTPResponse.Status
func (r ReadVreemdelingByIdResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ReadVreemdelingByIdResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type ReadProcessenByVreemdelingIdResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *ProcessenResponse
	JSON400      *BadRequestErrorResponse
}

// Status returns HTTPResponse.Status
func (r ReadProcessenByVreemdelingIdResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ReadProcessenByVreemdelingIdResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// ReadProcessenWithResponse request returning *ReadProcessenResponse
func (c *ClientWithResponses) ReadProcessenWithResponse(ctx context.Context, params *ReadProcessenParams, reqEditors ...RequestEditorFn) (*ReadProcessenResponse, error) {
	rsp, err := c.ReadProcessen(ctx, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseReadProcessenResponse(rsp)
}

// ReadProcesByIdWithResponse request returning *ReadProcesByIdResponse
func (c *ClientWithResponses) ReadProcesByIdWithResponse(ctx context.Context, procesId PathProcesId, params *ReadProcesByIdParams, reqEditors ...RequestEditorFn) (*ReadProcesByIdResponse, error) {
	rsp, err := c.ReadProcesById(ctx, procesId, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseReadProcesByIdResponse(rsp)
}

// ReadVreemdelingByIdWithResponse request returning *ReadVreemdelingByIdResponse
func (c *ClientWithResponses) ReadVreemdelingByIdWithResponse(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams, reqEditors ...RequestEditorFn) (*ReadVreemdelingByIdResponse, error) {
	rsp, err := c.ReadVreemdelingById(ctx, vreemdelingId, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseReadVreemdelingByIdResponse(rsp)
}

// ReadProcessenByVreemdelingIdWithResponse request returning *ReadProcessenByVreemdelingIdResponse
func (c *ClientWithResponses) ReadProcessenByVreemdelingIdWithResponse(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams, reqEditors ...RequestEditorFn) (*ReadProcessenByVreemdelingIdResponse, error) {
	rsp, err := c.ReadProcessenByVreemdelingId(ctx, vreemdelingId, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseReadProcessenByVreemdelingIdResponse(rsp)
}

// ParseReadProcessenResponse parses an HTTP response from a ReadProcessenWithResponse call
func ParseReadProcessenResponse(rsp *http.Response) (*ReadProcessenResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ReadProcessenResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest ProcessenResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	}

	return response, nil
}

// ParseReadProcesByIdResponse parses an HTTP response from a ReadProcesByIdWithResponse call
func ParseReadProcesByIdResponse(rsp *http.Response) (*ReadProcesByIdResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ReadProcesByIdResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest ProcesResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	}

	return response, nil
}

// ParseReadVreemdelingByIdResponse parses an HTTP response from a ReadVreemdelingByIdWithResponse call
func ParseReadVreemdelingByIdResponse(rsp *http.Response) (*ReadVreemdelingByIdResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ReadVreemdelingByIdResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest VreemdelingWithObservationsResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 410:
		var dest GoneErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON410 = &dest

	}

	return response, nil
}

// ParseReadProcessenByVreemdelingIdResponse parses an HTTP response from a ReadProcessenByVreemdelingIdWithResponse call
func ParseReadProcessenByVreemdelingIdResponse(rsp *http.Response) (*ReadProcessenByVreemdelingIdResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ReadProcessenByVreemdelingIdResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest ProcessenResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// Get all processen
	// (GET /processen)
	ReadProcessen(w http.ResponseWriter, r *http.Request, params ReadProcessenParams)
	// Find proces by ID
	// (GET /processen/{procesId})
	ReadProcesById(w http.ResponseWriter, r *http.Request, procesId PathProcesId, params ReadProcesByIdParams)
	// Find observations about a vreemdeling by ID
	// (GET /vreemdelingen/{vreemdelingId})
	ReadVreemdelingById(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadVreemdelingByIdParams)
	// Find processen about a vreemdling by ID
	// (GET /vreemdelingen/{vreemdelingId}/processen)
	ReadProcessenByVreemdelingId(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadProcessenByVreemdelingIdParams)
}

// Unimplemented server implementation that returns http.StatusNotImplemented for each endpoint.

type Unimplemented struct{}

// Get all processen
// (GET /processen)
func (_ Unimplemented) ReadProcessen(w http.ResponseWriter, r *http.Request, params ReadProcessenParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Find proces by ID
// (GET /processen/{procesId})
func (_ Unimplemented) ReadProcesById(w http.ResponseWriter, r *http.Request, procesId PathProcesId, params ReadProcesByIdParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Find observations about a vreemdeling by ID
// (GET /vreemdelingen/{vreemdelingId})
func (_ Unimplemented) ReadVreemdelingById(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadVreemdelingByIdParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Find processen about a vreemdling by ID
// (GET /vreemdelingen/{vreemdelingId}/processen)
func (_ Unimplemented) ReadProcessenByVreemdelingId(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadProcessenByVreemdelingIdParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// ReadProcessen operation middleware
func (siw *ServerInterfaceWrapper) ReadProcessen(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// Parameter object where we will unmarshal all parameters from the context
	var params ReadProcessenParams

	// ------------- Optional query parameter "attributes" -------------

	err = runtime.BindQueryParameter("form", false, false, "attributes", r.URL.Query(), &params.Attributes)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "attributes", Err: err})
		return
	}

	// ------------- Optional query parameter "sources" -------------

	err = runtime.BindQueryParameter("form", false, false, "sources", r.URL.Query(), &params.Sources)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "sources", Err: err})
		return
	}

	headers := r.Header

	// ------------- Optional header parameter "FSC-VWL-Verwerkings-Activiteit" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerkings-Activiteit")]; found {
		var FSCVWLVerwerkingsActiviteit externalRef0.FSCVWLVerwerkingsActiviteit
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerkings-Activiteit", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verwerkings-Activiteit", valueList[0], &FSCVWLVerwerkingsActiviteit, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerkings-Activiteit", Err: err})
			return
		}

		params.FSCVWLVerwerkingsActiviteit = &FSCVWLVerwerkingsActiviteit

	}

	// ------------- Optional header parameter "FSC-VWL-Verwerkings-Span" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerkings-Span")]; found {
		var FSCVWLVerwerkingsSpan externalRef0.FSCVWLVerwerkingsSpan
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerkings-Span", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verwerkings-Span", valueList[0], &FSCVWLVerwerkingsSpan, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerkings-Span", Err: err})
			return
		}

		params.FSCVWLVerwerkingsSpan = &FSCVWLVerwerkingsSpan

	}

	// ------------- Optional header parameter "FSC-VWL-Systeem" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Systeem")]; found {
		var FSCVWLSysteem externalRef0.FSCVWLSysteem
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Systeem", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Systeem", valueList[0], &FSCVWLSysteem, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Systeem", Err: err})
			return
		}

		params.FSCVWLSysteem = &FSCVWLSysteem

	}

	// ------------- Optional header parameter "FSC-VWL-Verwerker" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerker")]; found {
		var FSCVWLVerwerker externalRef0.FSCVWLVerwerker
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerker", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verwerker", valueList[0], &FSCVWLVerwerker, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerker", Err: err})
			return
		}

		params.FSCVWLVerwerker = &FSCVWLVerwerker

	}

	// ------------- Optional header parameter "FSC-VWL-Verantwoordelijke" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verantwoordelijke")]; found {
		var FSCVWLVerantwoordelijke externalRef0.FSCVWLVerantwoordelijke
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verantwoordelijke", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verantwoordelijke", valueList[0], &FSCVWLVerantwoordelijke, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verantwoordelijke", Err: err})
			return
		}

		params.FSCVWLVerantwoordelijke = &FSCVWLVerantwoordelijke

	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.ReadProcessen(w, r, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// ReadProcesById operation middleware
func (siw *ServerInterfaceWrapper) ReadProcesById(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "procesId" -------------
	var procesId PathProcesId

	err = runtime.BindStyledParameterWithOptions("simple", "procesId", chi.URLParam(r, "procesId"), &procesId, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "procesId", Err: err})
		return
	}

	// Parameter object where we will unmarshal all parameters from the context
	var params ReadProcesByIdParams

	// ------------- Optional query parameter "attributes" -------------

	err = runtime.BindQueryParameter("form", false, false, "attributes", r.URL.Query(), &params.Attributes)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "attributes", Err: err})
		return
	}

	// ------------- Optional query parameter "sources" -------------

	err = runtime.BindQueryParameter("form", false, false, "sources", r.URL.Query(), &params.Sources)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "sources", Err: err})
		return
	}

	headers := r.Header

	// ------------- Optional header parameter "FSC-VWL-Verwerkings-Activiteit" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerkings-Activiteit")]; found {
		var FSCVWLVerwerkingsActiviteit externalRef0.FSCVWLVerwerkingsActiviteit
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerkings-Activiteit", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verwerkings-Activiteit", valueList[0], &FSCVWLVerwerkingsActiviteit, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerkings-Activiteit", Err: err})
			return
		}

		params.FSCVWLVerwerkingsActiviteit = &FSCVWLVerwerkingsActiviteit

	}

	// ------------- Optional header parameter "FSC-VWL-Verwerkings-Span" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerkings-Span")]; found {
		var FSCVWLVerwerkingsSpan externalRef0.FSCVWLVerwerkingsSpan
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerkings-Span", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verwerkings-Span", valueList[0], &FSCVWLVerwerkingsSpan, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerkings-Span", Err: err})
			return
		}

		params.FSCVWLVerwerkingsSpan = &FSCVWLVerwerkingsSpan

	}

	// ------------- Optional header parameter "FSC-VWL-Systeem" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Systeem")]; found {
		var FSCVWLSysteem externalRef0.FSCVWLSysteem
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Systeem", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Systeem", valueList[0], &FSCVWLSysteem, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Systeem", Err: err})
			return
		}

		params.FSCVWLSysteem = &FSCVWLSysteem

	}

	// ------------- Optional header parameter "FSC-VWL-Verwerker" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerker")]; found {
		var FSCVWLVerwerker externalRef0.FSCVWLVerwerker
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerker", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verwerker", valueList[0], &FSCVWLVerwerker, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerker", Err: err})
			return
		}

		params.FSCVWLVerwerker = &FSCVWLVerwerker

	}

	// ------------- Optional header parameter "FSC-VWL-Verantwoordelijke" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verantwoordelijke")]; found {
		var FSCVWLVerantwoordelijke externalRef0.FSCVWLVerantwoordelijke
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verantwoordelijke", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verantwoordelijke", valueList[0], &FSCVWLVerantwoordelijke, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verantwoordelijke", Err: err})
			return
		}

		params.FSCVWLVerantwoordelijke = &FSCVWLVerantwoordelijke

	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.ReadProcesById(w, r, procesId, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// ReadVreemdelingById operation middleware
func (siw *ServerInterfaceWrapper) ReadVreemdelingById(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "vreemdelingId" -------------
	var vreemdelingId PathVreemdelingId

	err = runtime.BindStyledParameterWithOptions("simple", "vreemdelingId", chi.URLParam(r, "vreemdelingId"), &vreemdelingId, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "vreemdelingId", Err: err})
		return
	}

	// Parameter object where we will unmarshal all parameters from the context
	var params ReadVreemdelingByIdParams

	// ------------- Required query parameter "attributes" -------------

	if paramValue := r.URL.Query().Get("attributes"); paramValue != "" {

	} else {
		siw.ErrorHandlerFunc(w, r, &RequiredParamError{ParamName: "attributes"})
		return
	}

	err = runtime.BindQueryParameter("form", false, true, "attributes", r.URL.Query(), &params.Attributes)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "attributes", Err: err})
		return
	}

	// ------------- Optional query parameter "sources" -------------

	err = runtime.BindQueryParameter("form", false, false, "sources", r.URL.Query(), &params.Sources)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "sources", Err: err})
		return
	}

	headers := r.Header

	// ------------- Optional header parameter "FSC-VWL-Verwerkings-Activiteit" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerkings-Activiteit")]; found {
		var FSCVWLVerwerkingsActiviteit externalRef0.FSCVWLVerwerkingsActiviteit
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerkings-Activiteit", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verwerkings-Activiteit", valueList[0], &FSCVWLVerwerkingsActiviteit, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerkings-Activiteit", Err: err})
			return
		}

		params.FSCVWLVerwerkingsActiviteit = &FSCVWLVerwerkingsActiviteit

	}

	// ------------- Optional header parameter "FSC-VWL-Verwerkings-Span" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerkings-Span")]; found {
		var FSCVWLVerwerkingsSpan externalRef0.FSCVWLVerwerkingsSpan
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerkings-Span", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verwerkings-Span", valueList[0], &FSCVWLVerwerkingsSpan, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerkings-Span", Err: err})
			return
		}

		params.FSCVWLVerwerkingsSpan = &FSCVWLVerwerkingsSpan

	}

	// ------------- Optional header parameter "FSC-VWL-Systeem" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Systeem")]; found {
		var FSCVWLSysteem externalRef0.FSCVWLSysteem
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Systeem", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Systeem", valueList[0], &FSCVWLSysteem, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Systeem", Err: err})
			return
		}

		params.FSCVWLSysteem = &FSCVWLSysteem

	}

	// ------------- Optional header parameter "FSC-VWL-Verwerker" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerker")]; found {
		var FSCVWLVerwerker externalRef0.FSCVWLVerwerker
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerker", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verwerker", valueList[0], &FSCVWLVerwerker, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerker", Err: err})
			return
		}

		params.FSCVWLVerwerker = &FSCVWLVerwerker

	}

	// ------------- Optional header parameter "FSC-VWL-Verantwoordelijke" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verantwoordelijke")]; found {
		var FSCVWLVerantwoordelijke externalRef0.FSCVWLVerantwoordelijke
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verantwoordelijke", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verantwoordelijke", valueList[0], &FSCVWLVerantwoordelijke, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verantwoordelijke", Err: err})
			return
		}

		params.FSCVWLVerantwoordelijke = &FSCVWLVerantwoordelijke

	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.ReadVreemdelingById(w, r, vreemdelingId, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// ReadProcessenByVreemdelingId operation middleware
func (siw *ServerInterfaceWrapper) ReadProcessenByVreemdelingId(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "vreemdelingId" -------------
	var vreemdelingId PathVreemdelingId

	err = runtime.BindStyledParameterWithOptions("simple", "vreemdelingId", chi.URLParam(r, "vreemdelingId"), &vreemdelingId, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "vreemdelingId", Err: err})
		return
	}

	// Parameter object where we will unmarshal all parameters from the context
	var params ReadProcessenByVreemdelingIdParams

	// ------------- Optional query parameter "attributes" -------------

	err = runtime.BindQueryParameter("form", false, false, "attributes", r.URL.Query(), &params.Attributes)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "attributes", Err: err})
		return
	}

	// ------------- Optional query parameter "sources" -------------

	err = runtime.BindQueryParameter("form", false, false, "sources", r.URL.Query(), &params.Sources)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "sources", Err: err})
		return
	}

	headers := r.Header

	// ------------- Optional header parameter "FSC-VWL-Verwerkings-Activiteit" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerkings-Activiteit")]; found {
		var FSCVWLVerwerkingsActiviteit externalRef0.FSCVWLVerwerkingsActiviteit
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerkings-Activiteit", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verwerkings-Activiteit", valueList[0], &FSCVWLVerwerkingsActiviteit, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerkings-Activiteit", Err: err})
			return
		}

		params.FSCVWLVerwerkingsActiviteit = &FSCVWLVerwerkingsActiviteit

	}

	// ------------- Optional header parameter "FSC-VWL-Verwerkings-Span" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerkings-Span")]; found {
		var FSCVWLVerwerkingsSpan externalRef0.FSCVWLVerwerkingsSpan
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerkings-Span", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verwerkings-Span", valueList[0], &FSCVWLVerwerkingsSpan, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerkings-Span", Err: err})
			return
		}

		params.FSCVWLVerwerkingsSpan = &FSCVWLVerwerkingsSpan

	}

	// ------------- Optional header parameter "FSC-VWL-Systeem" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Systeem")]; found {
		var FSCVWLSysteem externalRef0.FSCVWLSysteem
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Systeem", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Systeem", valueList[0], &FSCVWLSysteem, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Systeem", Err: err})
			return
		}

		params.FSCVWLSysteem = &FSCVWLSysteem

	}

	// ------------- Optional header parameter "FSC-VWL-Verwerker" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerker")]; found {
		var FSCVWLVerwerker externalRef0.FSCVWLVerwerker
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerker", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verwerker", valueList[0], &FSCVWLVerwerker, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerker", Err: err})
			return
		}

		params.FSCVWLVerwerker = &FSCVWLVerwerker

	}

	// ------------- Optional header parameter "FSC-VWL-Verantwoordelijke" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verantwoordelijke")]; found {
		var FSCVWLVerantwoordelijke externalRef0.FSCVWLVerantwoordelijke
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verantwoordelijke", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithOptions("simple", "FSC-VWL-Verantwoordelijke", valueList[0], &FSCVWLVerantwoordelijke, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationHeader, Explode: false, Required: false})
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verantwoordelijke", Err: err})
			return
		}

		params.FSCVWLVerantwoordelijke = &FSCVWLVerantwoordelijke

	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.ReadProcessenByVreemdelingId(w, r, vreemdelingId, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/processen", wrapper.ReadProcessen)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/processen/{procesId}", wrapper.ReadProcesById)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/vreemdelingen/{vreemdelingId}", wrapper.ReadVreemdelingById)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/vreemdelingen/{vreemdelingId}/processen", wrapper.ReadProcessenByVreemdelingId)
	})

	return r
}

type BadRequestErrorResponseJSONResponse struct {
	Errors []Error `json:"errors"`
}

type GoneErrorResponseJSONResponse struct {
	Errors []Error `json:"errors"`
}

type ProcesResponseResponseHeaders struct {
	FSCVWLSysteem               string
	FSCVWLVerantwoordelijke     string
	FSCVWLVerwerker             string
	FSCVWLVerwerkingsActiviteit string
	FSCVWLVerwerkingsSpan       openapi_types.UUID
}
type ProcesResponseJSONResponse struct {
	Body ProcesResponse

	Headers ProcesResponseResponseHeaders
}

type ProcessenResponseResponseHeaders struct {
	FSCVWLSysteem               string
	FSCVWLVerantwoordelijke     string
	FSCVWLVerwerker             string
	FSCVWLVerwerkingsActiviteit string
	FSCVWLVerwerkingsSpan       openapi_types.UUID
}
type ProcessenResponseJSONResponse struct {
	Body ProcessenResponse

	Headers ProcessenResponseResponseHeaders
}

type VreemdelingWithObservationsResponseResponseHeaders struct {
	FSCVWLSysteem               string
	FSCVWLVerantwoordelijke     string
	FSCVWLVerwerker             string
	FSCVWLVerwerkingsActiviteit string
	FSCVWLVerwerkingsSpan       openapi_types.UUID
}
type VreemdelingWithObservationsResponseJSONResponse struct {
	Body VreemdelingWithObservationsResponse

	Headers VreemdelingWithObservationsResponseResponseHeaders
}

type ReadProcessenRequestObject struct {
	Params ReadProcessenParams
}

type ReadProcessenResponseObject interface {
	VisitReadProcessenResponse(w http.ResponseWriter) error
}

type ReadProcessen200JSONResponse struct{ ProcessenResponseJSONResponse }

func (response ReadProcessen200JSONResponse) VisitReadProcessenResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.Header().Set("FSC-VWL-Systeem", fmt.Sprint(response.Headers.FSCVWLSysteem))
	w.Header().Set("FSC-VWL-Verantwoordelijke", fmt.Sprint(response.Headers.FSCVWLVerantwoordelijke))
	w.Header().Set("FSC-VWL-Verwerker", fmt.Sprint(response.Headers.FSCVWLVerwerker))
	w.Header().Set("FSC-VWL-Verwerkings-Activiteit", fmt.Sprint(response.Headers.FSCVWLVerwerkingsActiviteit))
	w.Header().Set("FSC-VWL-Verwerkings-Span", fmt.Sprint(response.Headers.FSCVWLVerwerkingsSpan))
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response.Body)
}

type ReadProcessen400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response ReadProcessen400JSONResponse) VisitReadProcessenResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type ReadProcesByIdRequestObject struct {
	ProcesId PathProcesId `json:"procesId"`
	Params   ReadProcesByIdParams
}

type ReadProcesByIdResponseObject interface {
	VisitReadProcesByIdResponse(w http.ResponseWriter) error
}

type ReadProcesById200JSONResponse struct{ ProcesResponseJSONResponse }

func (response ReadProcesById200JSONResponse) VisitReadProcesByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.Header().Set("FSC-VWL-Systeem", fmt.Sprint(response.Headers.FSCVWLSysteem))
	w.Header().Set("FSC-VWL-Verantwoordelijke", fmt.Sprint(response.Headers.FSCVWLVerantwoordelijke))
	w.Header().Set("FSC-VWL-Verwerker", fmt.Sprint(response.Headers.FSCVWLVerwerker))
	w.Header().Set("FSC-VWL-Verwerkings-Activiteit", fmt.Sprint(response.Headers.FSCVWLVerwerkingsActiviteit))
	w.Header().Set("FSC-VWL-Verwerkings-Span", fmt.Sprint(response.Headers.FSCVWLVerwerkingsSpan))
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response.Body)
}

type ReadProcesById400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response ReadProcesById400JSONResponse) VisitReadProcesByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type ReadVreemdelingByIdRequestObject struct {
	VreemdelingId PathVreemdelingId `json:"vreemdelingId"`
	Params        ReadVreemdelingByIdParams
}

type ReadVreemdelingByIdResponseObject interface {
	VisitReadVreemdelingByIdResponse(w http.ResponseWriter) error
}

type ReadVreemdelingById200JSONResponse struct {
	VreemdelingWithObservationsResponseJSONResponse
}

func (response ReadVreemdelingById200JSONResponse) VisitReadVreemdelingByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.Header().Set("FSC-VWL-Systeem", fmt.Sprint(response.Headers.FSCVWLSysteem))
	w.Header().Set("FSC-VWL-Verantwoordelijke", fmt.Sprint(response.Headers.FSCVWLVerantwoordelijke))
	w.Header().Set("FSC-VWL-Verwerker", fmt.Sprint(response.Headers.FSCVWLVerwerker))
	w.Header().Set("FSC-VWL-Verwerkings-Activiteit", fmt.Sprint(response.Headers.FSCVWLVerwerkingsActiviteit))
	w.Header().Set("FSC-VWL-Verwerkings-Span", fmt.Sprint(response.Headers.FSCVWLVerwerkingsSpan))
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response.Body)
}

type ReadVreemdelingById400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response ReadVreemdelingById400JSONResponse) VisitReadVreemdelingByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type ReadVreemdelingById410JSONResponse struct{ GoneErrorResponseJSONResponse }

func (response ReadVreemdelingById410JSONResponse) VisitReadVreemdelingByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(410)

	return json.NewEncoder(w).Encode(response)
}

type ReadProcessenByVreemdelingIdRequestObject struct {
	VreemdelingId PathVreemdelingId `json:"vreemdelingId"`
	Params        ReadProcessenByVreemdelingIdParams
}

type ReadProcessenByVreemdelingIdResponseObject interface {
	VisitReadProcessenByVreemdelingIdResponse(w http.ResponseWriter) error
}

type ReadProcessenByVreemdelingId200JSONResponse struct{ ProcessenResponseJSONResponse }

func (response ReadProcessenByVreemdelingId200JSONResponse) VisitReadProcessenByVreemdelingIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.Header().Set("FSC-VWL-Systeem", fmt.Sprint(response.Headers.FSCVWLSysteem))
	w.Header().Set("FSC-VWL-Verantwoordelijke", fmt.Sprint(response.Headers.FSCVWLVerantwoordelijke))
	w.Header().Set("FSC-VWL-Verwerker", fmt.Sprint(response.Headers.FSCVWLVerwerker))
	w.Header().Set("FSC-VWL-Verwerkings-Activiteit", fmt.Sprint(response.Headers.FSCVWLVerwerkingsActiviteit))
	w.Header().Set("FSC-VWL-Verwerkings-Span", fmt.Sprint(response.Headers.FSCVWLVerwerkingsSpan))
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response.Body)
}

type ReadProcessenByVreemdelingId400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response ReadProcessenByVreemdelingId400JSONResponse) VisitReadProcessenByVreemdelingIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

// StrictServerInterface represents all server handlers.
type StrictServerInterface interface {
	// Get all processen
	// (GET /processen)
	ReadProcessen(ctx context.Context, request ReadProcessenRequestObject) (ReadProcessenResponseObject, error)
	// Find proces by ID
	// (GET /processen/{procesId})
	ReadProcesById(ctx context.Context, request ReadProcesByIdRequestObject) (ReadProcesByIdResponseObject, error)
	// Find observations about a vreemdeling by ID
	// (GET /vreemdelingen/{vreemdelingId})
	ReadVreemdelingById(ctx context.Context, request ReadVreemdelingByIdRequestObject) (ReadVreemdelingByIdResponseObject, error)
	// Find processen about a vreemdling by ID
	// (GET /vreemdelingen/{vreemdelingId}/processen)
	ReadProcessenByVreemdelingId(ctx context.Context, request ReadProcessenByVreemdelingIdRequestObject) (ReadProcessenByVreemdelingIdResponseObject, error)
}

type StrictHandlerFunc = strictnethttp.StrictHTTPHandlerFunc
type StrictMiddlewareFunc = strictnethttp.StrictHTTPMiddlewareFunc

type StrictHTTPServerOptions struct {
	RequestErrorHandlerFunc  func(w http.ResponseWriter, r *http.Request, err error)
	ResponseErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

func NewStrictHandler(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: StrictHTTPServerOptions{
		RequestErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		},
		ResponseErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusInternalServerError)
		},
	}}
}

func NewStrictHandlerWithOptions(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc, options StrictHTTPServerOptions) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: options}
}

type strictHandler struct {
	ssi         StrictServerInterface
	middlewares []StrictMiddlewareFunc
	options     StrictHTTPServerOptions
}

// ReadProcessen operation middleware
func (sh *strictHandler) ReadProcessen(w http.ResponseWriter, r *http.Request, params ReadProcessenParams) {
	var request ReadProcessenRequestObject

	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.ReadProcessen(ctx, request.(ReadProcessenRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "ReadProcessen")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(ReadProcessenResponseObject); ok {
		if err := validResponse.VisitReadProcessenResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// ReadProcesById operation middleware
func (sh *strictHandler) ReadProcesById(w http.ResponseWriter, r *http.Request, procesId PathProcesId, params ReadProcesByIdParams) {
	var request ReadProcesByIdRequestObject

	request.ProcesId = procesId
	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.ReadProcesById(ctx, request.(ReadProcesByIdRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "ReadProcesById")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(ReadProcesByIdResponseObject); ok {
		if err := validResponse.VisitReadProcesByIdResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// ReadVreemdelingById operation middleware
func (sh *strictHandler) ReadVreemdelingById(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadVreemdelingByIdParams) {
	var request ReadVreemdelingByIdRequestObject

	request.VreemdelingId = vreemdelingId
	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.ReadVreemdelingById(ctx, request.(ReadVreemdelingByIdRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "ReadVreemdelingById")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(ReadVreemdelingByIdResponseObject); ok {
		if err := validResponse.VisitReadVreemdelingByIdResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// ReadProcessenByVreemdelingId operation middleware
func (sh *strictHandler) ReadProcessenByVreemdelingId(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadProcessenByVreemdelingIdParams) {
	var request ReadProcessenByVreemdelingIdRequestObject

	request.VreemdelingId = vreemdelingId
	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.ReadProcessenByVreemdelingId(ctx, request.(ReadProcessenByVreemdelingIdRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "ReadProcessenByVreemdelingId")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(ReadProcessenByVreemdelingIdResponseObject); ok {
		if err := validResponse.VisitReadProcessenByVreemdelingIdResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xb3XPbuBH/VzDoPdy1pETJsh3rqb7LJeNOrpfGiTNT252ByJWEmAR4AChV9eh/7wAg",
	"RfBDEuXY+Widh8tJAvYLv13sLjb3OORJyhkwJfH4Hs+BRCDM/766/OXq45vLlVQAif4iAhkKmirKGR5j",
	"GgFTdEpBoCkXSM0BSb02QangIUhJ2cx8uwCxBHFH2Qx7WIZzSIimBv8mSRoDHuPJYoE9rFap/iCV0CvX",
	"ay8X4AoEYWrJuYggpp/uoCmK5pISoVZIgEw5k3QSw0aqkr+H1JxKFHGQiHGF5mQBSHE0AVSSiHhTcESV",
	"hHi6Rf6Qk93yayogdsndxrSTtLsV/hyBKZvJ81DRBVVAVdv5Iz6t28nQ9BxWc6VSOe73I6KIVBBLiHss",
	"7l+dv+v/fvH3/ocPFy8rQk65SIjCY5wJ6itI0pgo6CbsZUpYi40FYZKE+hPKMhp5iE6tYalEpLCfMaz+",
	"9EcGUiHKwjiLtEIEyZQwi26SAKIRknOexZE+BgEqEwyiisZHR+T06Hgw8QmMQn90Fgx88uJ45A8JTI+n",
	"Z6cjOBpuUTmjUYuqaw+nRJAE1FM6JtVbrfdjDzOSaBleXf7iX3184xe8vn//3almU9Tv0OH3aZjL9pUi",
	"QxfpNH3fYfBF40MhOmUhT7TgeUw4RHbD6RAX1x6u5m+Ne15ETSEvXmqxrPtqRNjA06vEnSCAEyDTYx9G",
	"p2f+6GQY+S8gGvqjkyCcnkRkEJxuHEBzK1VIC74e1spSAREeK5GBq8IPAqZ4jP/UL/OFvv1V9jcECk2u",
	"BECifYjNtquzKBdt02kwPBodn5y+OAvaJV9U+DxU/CoVrcMfGYjVuVKCTjIFsqnBLzxJiC9BB2YFEYqp",
	"VFqnQgBENpu1bnLOlxXNrjGJKZEaJKkAuFMkBoZv9Yo05hHg8ZTEEnKljTil1iXtnSo7zGpMqIJEVh3f",
	"XWHOUIHQrP91Tfz/3P7lhyZoN18QIchKf5ZqZWhptOOmFX83xiNxd2t+MSN+a0a75JkID8Hd5cXr386R",
	"tNu0sQyZHvqH/guRON78RqfmbpEphDpHiGoWndJQUZj69iIoPlEWdbVrzmebUV367UatStAw6o++/fun",
	"Pz/AvGvtLzbhM1x/JtE7G95/FYKLd/lv+qeQMwXM3G4kTWMaEn0E/U+Sm0ukRbl7DJqIxOPre5yAlGRm",
	"OXO0BKbQUnAt462OkYKnIBS1UhTbXEPtpODYbVdcMzo1jbJ2g8Z1wf12s4xPPkGobOJZi9tsQWIaIcrS",
	"TCGZabtoBK09/JozeFobatROecaih5rQJfDVLPiyFAP9OMmUyTUEzxTkOaouS4yVfzJ2tTnBg4y6S7Ea",
	"2RZJ82SjcBfs1VoDlbpgC7d8R79asNjcbEvC3YlSc1uVZpl+d6KVL2/SqCeihxCsJclbiBc56UFkzSZz",
	"ZPYYJbAnAohLuQUjb/LbJy0WP6PkW0SJk41/pGr++0SCWBhQPH5g6cKrBUmXWagRNM1ipMO62fAMpm8P",
	"TOsirTNnssntm4lqAmIGkb7JMjCpPCuzec/tr8Ux4g5IEJnwTCGqKnnpPXbXmLudlLw3ZUAoQGfF57rS",
	"HgaDEz8Y+MHw/eB4HIzGwfE/dREZmVLZ/vFb/lP80QmsSWUbKanRCY/x3/icoUvGlyafaPm2nqRUdaim",
	"KvvVGR75g6E/OHo/OB0fH49HgydVp1N65Hh3W+6dU3aTe4dJLYmyi72qkZoplYdtTtYA3Ps5IJOIITUn",
	"CvEwzHQdvpzTGKqNTyqLnk4NY9sz7vpJblZWCpfqprYuj6twQaNNR9ewDU1/44nmYroNMyqVjZbGyYqy",
	"LnR9yv7iNDlqarvQq1a0rQBs9adOrafdALzGLNaCMdxM74kbaLbV341a0BHf3VXTJBgHgdZk06OLiAJf",
	"0QTaaNJon1M4lr+IzBZbNT26KIU5txfPjS1Nj3StXgOo6VSWlvc2Lpozdg3cBmKbQjbxa79HS6rmuuZB",
	"lU5MGy4NDfes990HHVB8VjH4ISiuHec2kt3Bftv67frRBd90aWt91bqkyEoqFVGZ1CeazkAqIlSJKMom",
	"sCQaVVJBHNuHh2obtcJku0PbT1FEbW/wbWXVLjcrc491C/b2uX71Fu3mbxHE8Ng0bThxm/h7r/KhS7z9",
	"PcE96/tt7XS3sxb4Z7f3g2D9wyPFmQI77pYWGNXbdu7yVog1A1r9oeHzlG2LgM7rSP25IX/T2sTDXO1u",
	"gdEtvVoDpNN6caJiRBR5jo5fLzr6TxAdG+GxOOT9HZoGZs3W7air9YragCeB7cTe9TP4/pfAd7sVfa31",
	"6fOJf/8n3rG8LyLMnuePrRFnRy/wUbK+avA6R3eML5lb6Hq2yMh7Uc5rMmERmmZx7Lzbx7Aguqp2hKzX",
	"yaYt87Be1Gc1bwaP0ouiTawd4MVPoNbwcRyzGrv21+fNaY9ayncglLdfp84mC8RKo3NPevcMtm8PbA/K",
	"03ZFwc6htNpUaiDtwwc7UuUse9Bw2EF1ZbsIdsXTcF/sHiu78lmWTEDUhst2jJR1LQtNF2/Ki1cyEtoe",
	"QEJorCt8OqMxmfx1wWY9FjdvpvebaWMDPH3j5QM7b/gdKHT+9sI2rfXh6dtJX1AoF3kz5Hljhn84Q6+F",
	"mR74jc4EURTuQAFDryjEUUwmN7h3wy4UEpAKkBqIiCCZmAmgbCJBFfONAkjsL7mII3SDHWlucD4t7KFM",
	"QoQmKzvJSQTlmTRDqAyERNQORRO5irMk36ItHdMQ8miYTwT9+uHtGzToaQ/MROzMhEOWxj3I+oPesA+s",
	"bxINqswpvcpbUUYk7aMgpDVm0At6pqHEU2AkpXiMj3pB78ie5ty4Zb98kB7f4xm0zKi+M9OG0rw/uc/X",
	"m9dHkzW9AxK9dX5157Cv292+XNLfNv+29rptLabAOqzf/Q54+Hb73td1Y/nMehgn8wLafUv9Afa2Ns01",
	"DIJtwXizrm2wwcOjLju3DYuZR9EsSYhY4TF+DaoBKkVmGjB59LRpS4nR/n0RVdf74ZrT3YHUn1emN3UY",
	"VCvjx13x+QztbxHaT4TrV5RFxQT6ZIXMP9tpxbVz82psV+7s/QDXd0qzXqu/YOalnuKbe8ncYNIzlZ2m",
	"URR2lZTbXLIxkEjvVHMuoWRiRxVM4tL0LCeHe7B7VWfiD/exZ9/6mr7Vaa7pcx3Ow6NBh/3NWdsWV20Z",
	"qqm6UN2Jnd+qYxhd/PqQjKsc73evyc4+3tudpf28uqq90nx5V32+Dv8fMj3nRtT4rfpYBxcrb01NVpd+",
	"OULLKmnc78s5ERD5sS6E/AkJ74BF/mB4qsug3qDHaNqjfPwieBH0F4ExcrXIMht7JE1lL69TewzUkos7",
	"s/52I13dX39dgFipuRnSM6pNuQA608Vfn8QUmPQQF+gGVwLDDdaV4ctMhfNe67/TMiLWOrfObKAOA5In",
	"YBh7uhS2kcjkA+6AU8opU6YKpQloSzu/kVBx4bDnlTm1NkXVfFUqWpxpoaD93K5Zfojr2/V/AwAA//9R",
	"zJDQSj8AAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "https://gitlab.com/digilab.overheid.nl/ecosystem/fsc-vwl-api/-/raw/main/spec/openapi.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
